prologin/problems/urls.py
from django.urls import path
import problems.views

app_name = 'problems'

urlpatterns = [
    path('<int:year>/<type>', problems.views.Challenge.as_view(), name='challenge'),
    path('<int:year>/<type>/scoreboard', problems.views.ChallengeScoreboard.as_view(), name='challenge-scoreboard'),

    path('<int:year>/<type>/<problem>', problems.views.Problem.as_view(), name='problem'),
    path('<int:year>/<type>/<problem>/lang-template', problems.views.AjaxLanguageTemplate.as_view(), name='ajax-language-template'),
    path('<int:year>/<type>/<problem>/<int:submission>', problems.views.SubmissionCode.as_view(), name='submission'),

    path('submission-corrected/<int:submission>', problems.views.AjaxSubmissionCorrected.as_view(), name='ajax-submission-corrected'),
    path('submission-recorrect/<int:submission>', problems.views.RecorrectView.as_view(), name='submission-recorrect'),

    path('manual', problems.views.ManualView.as_view(), name='manual'),
    path('search', problems.views.SearchProblems.as_view(), name='search'),
    path('', problems.views.Index.as_view(), name='index'),
]

prologin/prologin/urls.py
from django.conf import settings
from django.conf.urls.static import static
from django.contrib import admin
from django.http import HttpResponse
from django.urls import path, include
from django.views.generic.base import TemplateView

import debug_toolbar

from homepage.views import HomepageView


def crash_test(request):
    if request.user.is_authenticated:
        1 / 0
    return HttpResponse(status=204)


urlpatterns = [
    # Debug toolbar
    path('__debug__/', include(debug_toolbar.urls)),

    # Homepage
    path('', HomepageView.as_view(), name='home'),

    # Built-in Django admin
    path('admin/', admin.site.urls),

    # Captcha
    path('captcha/', include('captcha.urls')),

    # Hijack
    path('hijack/', include('hijack.urls', namespace='hijack')),

    # Language selector
    path('lang/', include('django.conf.urls.i18n')),

    # News (blog)
    path('news/', include('news.urls')),

    # Forum
    path('forum/', include('forum.urls', namespace='forum')),

    # Teams
    path('team/', include('team.urls', namespace='team')),

    # Centers
    path('center/', include('centers.urls', namespace='centers')),

    # Documents
    path('docs/', include('documents.urls', namespace='documents')),

    # Archives
    path('archives/', include('archives.urls', namespace='archives')),

    # Contest
    path('contest/<int:year>/qualification/quiz/', include('qcm.urls', namespace='qcm')),
    path('contest/', include('contest.urls', namespace='contest')),

    # Training
    path('train/', include('problems.urls', namespace='problems')),

    # Authentication and accounts
    path('user/', include('users.urls', namespace='users')),

    # Mailing
    path('mailing/', include('massmailer.urls', namespace='massmailer')),

    # Schools
    path('schools/', include('schools.urls', namespace='schools')),

    # Sponsors
    path('sponsors/', include('sponsor.urls', namespace='sponsors')),

    # Crash test
    path('crashtest/', crash_test),

    # Pages
    path('', include('pages.urls', namespace='pages')),

    # Monitoring
    path('', include('django_prometheus.urls')),
]

if 'oidc_provider' in settings.INSTALLED_APPS and 'oidc_policy' in settings.INSTALLED_APPS:
    # OpenID Connect Provider
    urlpatterns.extend([path('openid/', include('oidc_provider.urls', namespace='oidc_provider')),])


if settings.DEBUG:
    urlpatterns.extend(static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT))
    urlpatterns.extend([
        path('e/400/', TemplateView.as_view(template_name='400.html')),
        path('e/403/', TemplateView.as_view(template_name='403.html')),
        path('e/404/', TemplateView.as_view(template_name='404.html')),
        path('e/500/', TemplateView.as_view(template_name='500.html')),
    ])

prologin/qcm/urls.py
from django.urls import path

import qcm.views

app_name = 'qcm'

urlpatterns = [
    path('', qcm.views.DisplayQCMView.as_view(), name='display'),
]

prologin/schools/urls.py
from django.urls import path, re_path, include

import schools.views
import schools.admin_views

app_name = 'schools'

admin_patterns = [
    re_path(r'^merge/(?P<pks>[0-9,]+)$', schools.admin_views.MergeView.as_view(), name='merge')
]

urlpatterns = [
    path('search', schools.views.SchoolSearchView.as_view(), name='search'),
    path('picture/<int:pk>', schools.views.FacebookPictureView.as_view(), name='fb-picture'),
    path('admin/', include((admin_patterns, app_name), namespace='admin')),
]

prologin/semifinal/urls.py
from django.conf import settings
from django.urls import path, include
from django.conf.urls.static import static
from django.contrib import admin
from django.views.generic.base import TemplateView

import semifinal.staff_views
import semifinal.views
import users.views

app_name = 'prologin'

urlpatterns = [
    # Built-in Django admin
    path('admin/', admin.site.urls),

    # Language selector
    path('lang/', include('django.conf.urls.i18n')),
]

monitoring_patterns = [
    path('', semifinal.staff_views.MonitoringIndexView.as_view(), name='index'),
    path('unlock', semifinal.staff_views.ExplicitUnlockView.as_view(), name='unlock'),
]

users_patterns = [
    # Login and logout
    path('login', users.views.LoginView.as_view(), name='login'),
    path('logout', users.views.LogoutView.as_view(), {'next_page': '/'}, name='logout'),
]

urlpatterns += [
    # Homepage
    path('', semifinal.views.Homepage.as_view(), name='home'),

    # Live scoreboard
    path('scoreboard', semifinal.views.Scoreboard.as_view(), name='scoreboard'),
    path('scoreboard/data', semifinal.views.ScoreboardData.as_view(), name='scoreboard-data'),

    # Contest monitoring
    path('contest/monitor/', include((monitoring_patterns, app_name), namespace='monitoring')),

    # Contest
    path('contest/', include('contest.urls', namespace='contest')),

    # Semifinal problems
    path('semifinal/', include('problems.urls', namespace='problems')),

    path('user/', include((users_patterns, app_name), namespace='users')),
]

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)
    urlpatterns += [
        path('e/400/', TemplateView.as_view(template_name='400.html')),
        path('e/403/', TemplateView.as_view(template_name='403.html')),
        path('e/404/', TemplateView.as_view(template_name='404.html')),
        path('e/500/', TemplateView.as_view(template_name='500.html')),
    ]

prologin/users/urls.py
from django.urls import path, include
from users import views, auth_token_views

app_name = 'users'

user_patterns = [
    path('profile', views.ProfileView.as_view(), name='profile'),
    path('edit', views.EditUserView.as_view(), name='edit'),
    path('edit/password', views.EditPasswordView.as_view(), name='edit_password'),
    path('delete', views.DeleteUserView.as_view(), name='delete'),
    path('takeout', views.TakeoutDownloadUserView.as_view(), name='takeout'),

    # Homes
    path('home/<int:year>', views.DownloadFinalHomeView.as_view(), name='download-final-home'),

    # Impersonate (django-hijack)
    path('impersonate', views.ImpersonateView.as_view(), name='impersonate'),
]

auth_token_patterns = [
    path('authorize', auth_token_views.AuthorizeView.as_view(), name='token-authorize'),
    # Internal to Prologin server, access should be restricted to internal IPs by nginx
    path('token', auth_token_views.AccessTokenView.as_view(), name='token-access'),
    path('refresh', auth_token_views.RefreshTokenView.as_view(), name='token-refresh'),
]

urlpatterns = [
    # User profile, view and edit
    path('<int:pk>/', include(user_patterns)),

    # Auth token stuff
    path('auth/', include(auth_token_patterns)),

    # Login and logout
    path('login', views.LoginView.as_view(), name='login'),
    path('logout', views.LogoutView.as_view(), name='logout'),

    # Search
    path('search/suggest', views.UserSearchSuggestView.as_view(), name='search-suggest'),

    # Password reset
    path('password/reset/ask', views.PasswordResetView.as_view(), name='password_reset'),
    path('password/reset/confirm/<uidb64>/<token>',
         views.PasswordResetConfirmView.as_view(), name='password_reset_confirm'),

    # Register and activate views
    path('register', views.RegistrationView.as_view(), name='register'),
    path('activate/<slug>', views.ActivationView.as_view(), name='activate'),

    # Mailing unsubscribe
    path('unsubscribe', views.UnsubscribeView.as_view(), name='unsubscribe'),
]

prologin/prologin/models.py
from django.db import models
from django.utils.translation import ugettext_noop, ugettext_lazy as _

from prologin.utils import ChoiceEnum
from prologin.languages import Language


@ChoiceEnum.labels(str.capitalize)
class Gender(ChoiceEnum):
    male = 0
    female = 1
    ugettext_noop("Male")
    ugettext_noop("Female")


class BaseEnumField:
    def __init__(self, enum, *args, **kwargs):
        assert issubclass(enum, ChoiceEnum)
        kwargs['choices'] = enum.choices(empty_label=kwargs.pop('empty_label', None))
        self._enum = enum
        super().__init__(*args, **kwargs)

    def deconstruct(self):
        name, path, args, kwargs = super().deconstruct()
        return name, path, [self._enum] + args, kwargs


class EnumField(BaseEnumField, models.PositiveSmallIntegerField):
    pass


class TextEnumField(BaseEnumField, models.CharField):
    def __init__(self, *args, **kwargs):
        kwargs['max_length'] = 64
        super().__init__(*args, **kwargs)


def _enumfield_factory(basecls, enumcls, name, **fieldkwargs):
    def init(self, *args, **kwargs):
        defaults = dict(fieldkwargs)
        defaults.update(kwargs)
        basecls.__init__(self, enumcls, *args, **defaults)

    def deconstruct(self):
        name, path, args, kwargs = basecls.deconstruct(self)
        return name, path, args[1:], kwargs

    return type(name, (basecls,), {'__init__': init, 'deconstruct': deconstruct})


GenderField = _enumfield_factory(EnumField, Gender, 'GenderField',
                                 empty_label=_("Other or prefer not to tell"), verbose_name=_("Gender"))

CodingLanguageField = _enumfield_factory(TextEnumField, Language, 'CodingLanguageField',
                                         verbose_name=_("Coding language"))


class AddressableModel(models.Model):
    address = models.TextField(blank=True, verbose_name=_("Address"))
    postal_code = models.CharField(max_length=32, blank=True, verbose_name=_("Postal code"))
    city = models.CharField(max_length=64, blank=True, verbose_name=_("City"))
    country = models.CharField(max_length=64, blank=True, verbose_name=_("Country"))

    class Meta:
        abstract = True


class ContactModel(models.Model):
    contact_gender = GenderField(null=True, blank=True)
    contact_position = models.CharField(max_length=128, blank=True)
    contact_first_name = models.CharField(max_length=64, blank=True)
    contact_last_name = models.CharField(max_length=64, blank=True)
    contact_phone_desk = models.CharField(max_length=16, blank=True)
    contact_phone_mobile = models.CharField(max_length=16, blank=True)
    contact_phone_fax = models.CharField(max_length=16, blank=True)
    contact_email = models.EmailField(blank=True)

    def get_full_name(self):
        return " ".join(field for field in
                        (self.contact_first_name, self.contact_last_name) if field)

    class Meta:
        abstract = True

prologin/prologin/utils/forms.py
from django import forms
from prologin.utils import _


class NewableModelChoiceField(forms.ModelChoiceField):
    def to_python(self, value):
        try:
            return super().to_python(value)
        except forms.ValidationError as exc:
            return self.create_new(self.queryset.model, value, exc)

    def create_new(self, model, value, exc):
        raise NotImplementedError()


class ConfirmDangerMixin(forms.Form):
    password_conf = forms.CharField(widget=forms.PasswordInput, label=_("Your current password"))

    def __init__(self, *args, **kwargs):
        # the user doing the dangerous operation, who must provide their password
        self.action_user = kwargs.pop('action_user')
        super().__init__(*args, **kwargs)

    def clean_password_conf(self):
        if not self.action_user.check_password(self.cleaned_data['password_conf']):
            raise forms.ValidationError(_("Wrong password."))

prologin/semifinal/forms.py
from django import forms
from django.utils.translation import ugettext_lazy as _

import contest.models
import problems.models


class ExplicitProblemUnlockForm(forms.Form):
    problem = forms.ChoiceField(label=_("Problem"))
    contestants = forms.ModelMultipleChoiceField(queryset=(contest.models.Contestant.objects
                                                           .select_related('user')
                                                           .filter(user__is_staff=False, user__is_superuser=False)),
                                                 label=_("Contestants"),
                                                 help_text=_("You can select all contestants using Ctrl-A."))

    @staticmethod
    def contestant_label(contestant):
        user = contestant.user
        return "{} ({})".format(user.username, user.get_full_name())

    @staticmethod
    def problem_label(problem):
        return "[{}] {}".format(problem.difficulty, problem.title)

    def __init__(self, *args, **kwargs):
        challenge = kwargs.pop('challenge')
        assert isinstance(challenge, problems.models.Challenge)

        super().__init__(*args, **kwargs)

        self.fields['problem'].choices = [(problem.name, ExplicitProblemUnlockForm.problem_label(problem))
                                          for problem in challenge.problems]

        self.fields['contestants'].queryset = (self.fields['contestants'].queryset
                                               .filter(edition=challenge.year))
        self.fields['contestants'].label_from_instance = ExplicitProblemUnlockForm.contestant_label

prologin/prologin/views.py
from django.core.exceptions import ImproperlyConfigured


class ChoiceGetAttrsMixin(object):
    """
    Mixin that handles a list of GET attributes that can be user-set to a predefined list of valid choices.
    Handles validation and fallback. User class has to use get_clean_attr('name') to access validated attributes.

    The list of attributes is get_attrs; you can also implement get_get_attrs().
    The first item of the choice list will be the default. You can use the None literal.

    Usage:

        class MyView(ChoiceGetAttrsMixin, View):
            get_attrs = {'sort': ['name', 'age', 'city'],
                         'order': ['asc', 'desc']}

            def some_method(self):
                sort = self.get_clean_attr('sort')
                ...
    """

    get_attrs = {}

    def get_get_attr(self):
        return self.get_attrs

    def get_clean_attr(self, attr):
        attrs = self.get_get_attr()
        try:
            choices = attrs[attr]
        except KeyError:
            raise KeyError("{} is not defined in get_attrs".format(attr))
        choices = list(choices)
        try:
            fallback = choices[0]
        except IndexError:
            raise ImproperlyConfigured("Attribute {} has an empty choice list".format(attr))
        value = self.request.GET.get(attr, fallback)
        if value not in choices:
            value = fallback
        return value

prologin/semifinal/views.py
from django.contrib.auth import get_user_model
from django.db.models.aggregates import Sum
from django.http import JsonResponse
from django.template.loader import get_template
from django.views.generic import TemplateView, View
from rules.contrib.views import PermissionRequiredMixin

from problems.models import Submission
from prologin.utils.scoring import decorate_with_rank

User = get_user_model()


class ScoreboardUserListMixin:
    def get_user_list(self):
        users = (User.objects
                 .filter(is_active=True, is_staff=False, is_superuser=False)
                 .annotate(score=Sum(Submission.get_score_func('training_submissions')))
                 .order_by('-score', 'username'))

        def score_getter(user):
            return user.score

        def decorator(user, rank, ex_aequo):
            user.rank = rank
            user.ex_aequo = ex_aequo

        decorate_with_rank(users, score_getter, decorator)
        return users


class ParticipateRequiredMixin(PermissionRequiredMixin):
    permission_required = 'semifinal.participate'


class Homepage(ParticipateRequiredMixin, TemplateView):
    template_name = 'semifinal/homepage.html'


class Scoreboard(ScoreboardUserListMixin, TemplateView):
    template_name = 'semifinal/scoreboard.html'

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context['users'] = self.get_user_list()
        return context


class ScoreboardData(ScoreboardUserListMixin, View):
    def get(self, context, **kwargs):
        return JsonResponse(self.get_json_data(), safe=False)

    def get_json_data(self):
        users = self.get_user_list()
        template = get_template('semifinal/stub-scoreboard-item.html')
        return [{'id': '#sb-{}'.format(user.pk), 'html': template.render({'user': user})}
                for user in users]

prologin/semifinal/templates/prologin/base.html
{% load i18n staticfiles %}
{% load django_bootstrap_breadcrumbs utils %}

{% get_current_language as LANGUAGE_CODE %}
<!doctype html>
<html lang="{{ LANGUAGE_CODE }}">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">

  <title>{% block super_title %}{% block title %}{% endblock %} – Prologin{% endblock %}</title>

  {# Boostrap, FontAwesome #}
  <link rel="stylesheet" href="{% static 'vendor/bootstrap/dist/css/bootstrap.min.css' %}"/>
  <link rel="stylesheet" href="{% static 'vendor/font-awesome/css/font-awesome.min.css' %}"/>

  {# Custom #}
  <link rel="stylesheet" type="text/css" href="{% static 'css/prologin.css' %}"/>

  <meta name="description" content="{% block meta_descr %}{% endblock %}">

{% include "prologin/favicons.html" %}

  {% block extra_head %}{% endblock %}
</head>
<body class="tex2jax_ignore {% block body_class %}{% endblock %}" {% block body_tag %}{% endblock %}>

  {# Header #}
  {% block super_header %}
  <div class="navbar-header">
    <div class="navbar navbar-default">
    <div class="container">
        <div class="navbar-brand">
          <a href="{% url 'home' %}">
            <img src="{% static 'img/logo_cube.png' %}" width="50" height="53" alt="Prologin">
            Prologin
            <small>{% get_setting 'PROLOGIN_EDITION' %}</small>
          </a>
        </div>
        <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-collapse">
          <span class="icon-bar"></span>
          <span class="icon-bar"></span>
          <span class="icon-bar"></span>
        </button>
        <div class="navbar-collapse collapse pull-right">
          {% include "prologin/main-menu.html" %}
        </div>
      </div>
    </div>
  </div>
  {% endblock super_header %}

  {% block super_content %}
  {# Content #}
  <div class="container">
    {% block breadcrumbs %}
      {% clear_breadcrumbs %}
      {% breadcrumb_for "home" %}{% trans "Prologin" %}{% endbreadcrumb_for %}
    {% endblock %}

    {% render_breadcrumbs "django_bootstrap_breadcrumbs/bootstrap3.html" %}

    {% include "prologin/messages.html" %}

    {% block content %}

    {% endblock %}
  </div>
  {% endblock super_content %}

  {# Footer #}
  <footer>
    <div class="container">
      {% include "prologin/main-footer.html" %}
    </div>
  </footer>

  {# Scripts #}
  <script src="{% static 'vendor/jquery/dist/jquery.min.js' %}"></script>
  <script src="{% static 'vendor/bootstrap/dist/js/bootstrap.min.js' %}"></script>
  {% block extra_script %}{% endblock %}
</body>
</html>

prologin/semifinal/templates/prologin/main-footer.html
{% load i18n %}
{% load utils %}

<div class="row">
  <div class="col-xs-6 col-md-4">
    <h3>{% trans "Prologin" %}</h3>
    <p><strong>{% blocktrans with center=request.current_event.center.name %}Regional event at {{ center }}{% endblocktrans %}</strong></p>
  </div>
  <div class="col-xs-6 col-md-4">
  </div>
  <div class="col-xs-12 col-md-4">
    <h3>{% trans "Change locale" %} <i class=" fa fa-globe"></i></h3>
    {% get_current_language as LANGUAGE_CODE %}
    <form action="{% url 'set_language' %}" method="post" id="change-lang-form" class="form-inline">
      {% csrf_token %}
      {# <input name="next" type="hidden" value="{{ redirect_to }}"/> #}
      <select name="language" id="set-language" class="form-control" onchange="$('#change-lang-form').submit();">
        {% get_available_languages as LANGUAGES %}
        {% get_language_info_list for LANGUAGES as languages %}
        {% for language in languages %}
          <option value="{{ language.code }}"{% if language.code == LANGUAGE_CODE %}
              selected="selected"{% endif %}>{{ language.name_local.title }}</option>
        {% endfor %}
      </select>
      <noscript><input type="submit" class="btn btn-default" value="{% trans "Apply" %}"/></noscript>
      {% if request.user.is_authenticated and LANGUAGE_CODE != request.user.preferred_locale %}
        {% url 'users:edit' request.user.pk as user_edit_url %}
        <p><small class="text-muted">{% blocktrans with url=user_edit_url %}Save your
preferred locale in your <a href="{{ url }}#id_preferred_locale">user settings</a>.{% endblocktrans %}</small></p>
      {% endif %}
    </form>
  </div>
</div>

prologin/semifinal/templates/prologin/main-menu.html
{% load i18n %}
{% load navigation rules %}

<ul class="nav navbar-nav pull-right">
{% if request.user.is_authenticated %}
  <li class="{% active '^/semifinal/' %}"><a href="{% url 'problems:challenge' request.current_edition.year 'semifinal' %}">{% trans "Problems" %}</a></li>
{% endif %}
  <li class="{% active '^/scoreboard' %}"><a href="{% url 'scoreboard' %}">{% trans "Scoreboard" %}</a></li>
{% if request.user.is_staff %}
  <li class="dropdown">
    <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-expanded="false"><i class="fa fa-star"></i> {% trans "Admin" %} <span class="caret"></span></a>
    <ul class="dropdown-menu dropdown-menu-right" role="menu">
      <li><a href="{% url 'admin:index' %}">{% trans "Django administration" %}</a></li>
      <li class="divider"></li>
      {% has_perm 'semifinal.monitor' request.user None as can_monitor %}
      {% if can_monitor %}<li><a href="{% url 'monitoring:index' %}"><i class="fa fa-wrench"></i> {% trans "Regional event monitoring" %}</a></li>{% endif %}
    </ul>
  </li>
{% endif %}
  <li class="sep"><a>&nbsp;</a></li>
  {% if user.is_authenticated %}
  <li class="dropdown">
    <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-expanded="false"><i class="fa fa-user"></i> {{ user.username }} <span class="caret"></span></a>
    <ul class="dropdown-menu dropdown-menu-right" role="menu">
      <li><form method="post" action="{% url 'users:logout' %}">{% csrf_token %}<button type="submit"><i class="fa fa-power-off"></i> {% trans "Sign out" %}</button></form></li>
    </ul>
  </li>
  {% else %}
  <li class="{% active 'users:login' %}">
    <a href="{% url 'users:login' %}?{% querystring request next=request.path %}">{% trans "Sign in" %}</a>
  </li>
  {% endif %}
</ul>